<?php
/**
* Author: Alessandro Pasotti - www.itopen.it
* @package SimpleACL
* @copyright Copyright (C) 2007 Alessandro Pasotti. All rights reserved.
* @license GNU AFFERO GENERAL PUBLIC LICENSE - AGPL V.3
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onAfterStart', 'botSimpleACL' );

function botSimpleACL() {
    global $mosConfig_absolute_path, $mosConfig_live_site, $mainframe, $database;

    $my = $mainframe->getUser();
    $option = mosGetParam($_REQUEST, "option");

    // Check component and if user is logged in, skip administrators
    if(!$my->id || $my->usertype == 'Super Administrator' || $my->usertype == 'Administrator' || ($option != 'com_content' && $option != 'com_mycontent')){
        return;
    }


    $task       = mosGetParam($_REQUEST, "task");
    $sectionid  = mosGetParam($_REQUEST, "sectionid");
    $id         = mosGetParam($_REQUEST, "id");

    // Map task to action
    switch($task){
        case 'new' :
            $aclaction = 'c';
        break;
        case 'edit' :
            $aclaction = 'u';
        break;
        case 'delete' :
            $aclaction = 'd';
        break;
        default:
           $aclaction = 'r';
    }

    // Get section
    if(!$sectionid){
        if(strpos($task, 'category') !== false){
            $database->setQuery("SELECT section FROM #__categories WHERE id = $id");
            $sectionid = $database->loadResult();
        } elseif(strpos($task, 'section') !== false){
            $sectionid = $id;
        } else {
            $database->setQuery("SELECT sectionid FROM #__content WHERE id = $id");
            $sectionid = $database->loadResult();
        }
    }

    // No section?
    if(!$sectionid){
        return;
    }

    // Check access
    // Get default policy
    @include($mosConfig_absolute_path."/administrator/components/com_simpleacl/config.simpleacl.php");

    // Get access for user
    $aclaccess = true;
    $database->setQuery("SELECT * FROM #__simpleacl WHERE sectionid = $sectionid AND userid = $my->id");
    $acls = $database->loadObjectList();
    // Ok, check if there is an ACL and decide what to do following the default policy
    if(!count($acls)){
	$aclaccess = (strpos($default_policy, $aclaction) !== false);
    } else { // Check if match
        $aclaccess = (strpos($acls[0]->action, $aclaction) !== false);
    }

    // Debug print
    //echo "botSimpleACL : action = $aclaction, sectionid = $sectionid, aclaccess = $aclaccess, task = $task <br />";

    if(!$aclaccess){
        // Do something here
        mosRedirect('index.php?option=simpleacl&amp;task=deny');
        exit();
    }

} // end function botSimpleACL
?>